#include "stdio.h"
#include "sm_timer.h"
#include "debug.h"


smtimer_elem_t smtimer_array[SM_TIMER_NUM];
u32 smtimer_ms = 0;

void smtimer_tick_cnt(u32 ms)
{
    smtimer_ms += ms;
}

u8 smtimer_set_timer(u16 ms,func *pfn,void *arg,u16 loops)
{
    u8 i;

    for(i=0;i<SM_TIMER_NUM;i++)
    {
        if(smtimer_array[i].runtime == 0)
        {
            smtimer_array[i].runtime = smtimer_ms + ms;
            smtimer_array[i].pfn = pfn;
            smtimer_array[i].arg = arg;

            smtimer_array[i].ms = ms;
            smtimer_array[i].run_loops = loops;            
            return 0;//success            
        }
    }

    if(i>=SM_TIMER_NUM)
    {
        DBG_print(DBG_INFO,"smtimer full!");
    }

    return 1; // fail
}

void smtimer_proc()
{    
    u8 i;
    u32 nowtime_ms = smtimer_ms;
    for(i=0;i<SM_TIMER_NUM;i++)
    {
        if(smtimer_array[i].runtime != 0 && nowtime_ms >= smtimer_array[i].runtime)
        {   
            if(smtimer_array[i].run_loops > 1)
            {
                smtimer_array[i].runtime += smtimer_array[i].ms;
                
                if(smtimer_array[i].run_loops != SMTIMER_LOOPS_FOREVER)
                    smtimer_array[i].run_loops--;
            }
            else
                smtimer_array[i].runtime = 0;
            
            if(smtimer_array[i].pfn)
                smtimer_array[i].pfn(smtimer_array[i].arg);
            
        }
    }
}

void smtimer_init()
{
    memset(&smtimer_array,0,sizeof(smtimer_array));
}

